package re;

import java.io.FileReader;

import re.ast.RENode;
import re.error.LexicalError;
import re.error.REError;
import re.lex.Lexer;
import re.parser._;

object Main {

  def main(args: Array[String]) = {

    var n = 0;

    // If first command line argument is -d, turn on debugging
    if (args.length > n && args(n).equals("-d")) {
      Util.debug = true;
      n = n + 1;
    }

    // Get name of file
    if (args.length == n) {
      System.out.println("No file given.");
    } else {
      val fileName = args(n);

      // example of debug message: This message will only be printed if
      // you provide "-d" on the command line.
      Util.debug("Processing %s...", fileName);

      
      try {
        val programParser: parser = new parser(new Lexer(new FileReader(fileName)));
        val re: RENode = programParser.parse().value.asInstanceOf[RENode];

        // TODO: Write PrettyPrint and print re.

        // TODO: Write NFABuilder and build NFA from re.

      } catch {
        case (e: LexicalError) => printf("%s\n", e.getMessage())
        case (e: REError)      => printf("%s\n", e.getMessage());
      }
    }
  }
}
